package com.nisum.poc.Webflux.service.impl;

import com.nisum.poc.Webflux.entity.Address;
import com.nisum.poc.Webflux.entity.Student;
import com.nisum.poc.Webflux.entity.Subject;
import com.nisum.poc.Webflux.model.StudentPayload;
import com.nisum.poc.Webflux.repository.AddressRepository;
import com.nisum.poc.Webflux.repository.StudentRepository;
import com.nisum.poc.Webflux.repository.SubjectRepository;
import com.nisum.poc.Webflux.service.IStudentService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
import reactor.util.function.Tuple2;

import java.util.ArrayList;
import java.util.List;


@Service
@Slf4j
public class StudentServiceImpl implements IStudentService {


    @Autowired
    StudentRepository studentRepository;
    @Autowired
    AddressRepository addressRepository;
    @Autowired
    SubjectRepository subjectRepository;
    @Override
    public Mono<Student> createStudent(Student student) {
        Student student1 = new Student();
        student1.setId(student.getId());
        student1.setAge(student.getAge());
        student1.setFirstName(student.getFirstName());
        student1.setLastName(student.getLastName());
        student1.setPhoneNumbers(student.getPhoneNumbers());
        Mono<Student> studentMono = studentRepository.save(student1);

        List<Address> addressList = new ArrayList<>();
        List<Subject> subjectList = new ArrayList<>();

        studentMono.subscribe(studentmono -> {
            student.getAddress().forEach(address -> {
                Address address1 = new Address();
                address1.setId(address.getId());
                address1.setAddress(address.getAddress());
                address1.setStudentId(studentmono.getId());
                address1.setCity(address.getCity());
                address1.setAddressType(address.getAddressType());
                address1.setPinCode(address.getPinCode());
                addressList.add(address1);
            });
            student.getSubjects().forEach(sub -> {
                Subject subject = new Subject();
                subject.setId(sub.getId());
                subject.setSubjectName(sub.getSubjectName());
                subject.setStudentId(studentmono.getId());
                subjectList.add(subject);
            });
            Flux<Address> addressFlux = addressRepository.saveAll(addressList);
            Flux<Subject> subjectFlux = subjectRepository.saveAll(subjectList);
        });
        return studentMono;
    }
    @Override
    public Flux<StudentPayload> getAllStudents() {
       return studentRepository.findAll().flatMap(student -> {
             Flux<Address> addressFlux = addressRepository.findByStudentId(student.getId()).switchIfEmpty(Flux.just(new Address()));
             Flux<Subject> subjectFlux = subjectRepository.findByStudentId(student.getId()).switchIfEmpty(Flux.just(new Subject()));
             StudentPayload studentPayload = new StudentPayload();
             studentPayload.setId(student.getId());
             studentPayload.setAge(student.getAge());
             studentPayload.setPhoneNumbers(student.getPhoneNumbers());
             studentPayload.setFirstName(student.getFirstName());
             studentPayload.setLastName(student.getLastName());
             studentPayload.setAddresses(addressFlux.collectList().block());
             studentPayload.setSubjects(subjectFlux.collectList().block());
             Flux<StudentPayload> studentPayloadFlux = Flux.just(studentPayload);
             return studentPayloadFlux;
         });
       // return studentFlux;
    }

    public Flux<String> concat() {
        Flux<String> names1 = Flux.just("Hi ", " Hello ", "how ");
        Flux<String> names2 = Flux.just("are ", " you ", " Doing");
        Flux<String> names = Flux.concat(names1, names2).log();
        return names;
    }

    public Flux<String> merge() {
        Flux<String> names1 = Flux.just("Hi ", " Hello ", "how ");
        Flux<String> names2 = Flux.just("are ", " you ", " Doing");
        Flux<String> names = Flux.merge(names1, names2).log();
        return names;
    }

    public Flux<Integer> combineWithZip(){

        Flux<Integer> name1 = Flux.just(1, 2, 3);
        Flux<Integer> name2 = Flux.just(4,5,6);
        Flux<Integer> name3 = Flux.zip(name1,name2,(n1, n2)->{
            return n1*n2;
        });
        return name3;
    }
    public Mono<String> combineWithZipChara(){

        Mono<String> name1 = Mono.just("Hi");
        Mono<String> name2 = Mono.just("are");
        Flux<String> name3 = Mono.zip(name1,name2).flatMap(a ->{
            a.getT1().toString();
        });

    }

}
